const project = new Siesta.Project.Browser()

project.configure({
  title: 'Vuestic Admin Dashboard test suite',
})

project.plan(
  {
    // Tests in this group, exercises individual components
    group: 'Individual components tests',

    // our entry page for Siesta tests
    pageUrl: '../entry.html',

    items: [
      'components/color_picker.t.js',
    ],
  },
  {
    // This is end-to-end tests group, access application as a "black box"
    // they open the `index.html` page using the `pageUrl` config
    // and then executes as a script on that page
    group: 'Black box tests',

    pageUrl: '../index.html',

    items: [
      'blackbox-app/sanity.t.js',
    ],
  },
)

project.start()
