Ext.data.JsonP.Siesta_Recorder_Role_CanRecordPointOfInterest({"tagname":"class","name":"Siesta.Recorder.Role.CanRecordPointOfInterest","autodetected":{},"files":[{"filename":"CanRecordPointOfInterest.js","href":"CanRecordPointOfInterest.html#Siesta-Recorder-Role-CanRecordPointOfInterest"}],"members":[{"name":"moveCursorToSelectors","tagname":"cfg","owner":"Siesta.Recorder.Role.CanRecordPointOfInterest","id":"cfg-moveCursorToSelectors","meta":{}},{"name":"recordPointsOfInterest","tagname":"cfg","owner":"Siesta.Recorder.Role.CanRecordPointOfInterest","id":"cfg-recordPointsOfInterest","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-Siesta.Recorder.Role.CanRecordPointOfInterest","short_doc":"A mixin, providing the feature of recording the \"moveCursorTo\" event, when cursor is moved over certain\n\"point of int...","component":false,"superclasses":[],"subclasses":[],"mixedInto":["Siesta.Recorder.Recorder"],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Mixed into</h4><div class='dependency'><a href='#!/api/Siesta.Recorder.Recorder' rel='Siesta.Recorder.Recorder' class='docClass'>Siesta.Recorder.Recorder</a></div><h4>Files</h4><div class='dependency'><a href='source/CanRecordPointOfInterest.html#Siesta-Recorder-Role-CanRecordPointOfInterest' target='_blank'>CanRecordPointOfInterest.js</a></div></pre><div class='doc-contents'><p>A mixin, providing the feature of recording the \"moveCursorTo\" event, when cursor is moved over certain\n\"point of interest\", which can be specified as an array of CSS selectors: <a href=\"#!/api/Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-moveCursorToSelectors\" rel=\"Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-moveCursorToSelectors\" class=\"docClass\">moveCursorToSelectors</a>.</p>\n\n<p>This feature ensures that cursor is following the same path, activating the same UI elements as during recording\nsession, like menu items, various hover elements etc.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-moveCursorToSelectors' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Recorder.Role.CanRecordPointOfInterest'>Siesta.Recorder.Role.CanRecordPointOfInterest</span><br/><a href='source/CanRecordPointOfInterest.html#Siesta-Recorder-Role-CanRecordPointOfInterest-cfg-moveCursorToSelectors' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-moveCursorToSelectors' class='name expandable'>moveCursorToSelectors</a> : Array[String]<span class=\"signature\"></span></div><div class='description'><div class='short'>An array of strings with CSS selectors. ...</div><div class='long'><p>An array of strings with CSS selectors. If the mouse is\nmoved upon a target, matching any of these selectors, a <code>moveCursorTo</code> will be recorded.</p>\n\n<p>Used with <a href=\"#!/api/Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-recordPointsOfInterest\" rel=\"Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-recordPointsOfInterest\" class=\"docClass\">recordPointsOfInterest</a> option.</p>\n</div></div></div><div id='cfg-recordPointsOfInterest' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Recorder.Role.CanRecordPointOfInterest'>Siesta.Recorder.Role.CanRecordPointOfInterest</span><br/><a href='source/CanRecordPointOfInterest.html#Siesta-Recorder-Role-CanRecordPointOfInterest-cfg-recordPointsOfInterest' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-recordPointsOfInterest' class='name expandable'>recordPointsOfInterest</a> : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>Set this option to true to enable recording of \"points of interest\",\nspecified with the moveCursorToSelectors CSS sel...</div><div class='long'><p>Set this option to <code>true</code> to enable recording of \"points of interest\",\nspecified with the <a href=\"#!/api/Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-moveCursorToSelectors\" rel=\"Siesta.Recorder.Role.CanRecordPointOfInterest-cfg-moveCursorToSelectors\" class=\"docClass\">moveCursorToSelectors</a> CSS selectors</p>\n\n<p>This is useful in lots of scenarios, for example when triggering a menu item to show. You cannot click the menu item right away,\nsince it's hidden until you move the cursor over the top-level menu header.</p>\n\n<p>So if you will add the CSS selector for the top-level menu header in this config, recorder will insert <code>moveCursorTo</code> actions\nevery time mouse hovers it. This makes recording complex scenarios more robust.</p>\n<p>Defaults to: <code>true</code></p></div></div></div></div></div></div></div>","meta":{}});